local function catmulspoint(t, p0, p1, p2, p3)
	local x = 0.5 *((2 * p1.x) + (-p0.x + p2.x) * t + (2*p0.x - 5*p1.x + 4*p2.x - p3.x) * t*t + (-p0.x + 3*p1.x- 3*p2.x + p3.x) * t*t*t)
	local y = 0.5 *((2 * p1.y) + (-p0.y + p2.y) * t + (2*p0.y - 5*p1.y + 4*p2.y - p3.y) * t*t + (-p0.y + 3*p1.y- 3*p2.y + p3.y) * t*t*t)
	return {x = x, y = y}
end

local function catmulspline(p0, p1, p2, p3, step)
	step = step or 0.1
	local ret = {}
	for i = 0,1,step do
		ret[#ret+1] = catmulspoint(i, p0, p1, p2, p3)
	end
	return ret
end

function Shape:catmulTo(startx, starty, p1x, p1y, p2x, p2y, x, y)
	local p = catmulspline({x=startx, y=starty}, {x=p1x, y=p1y}, {x=p2x, y=p2y}, {x=x, y=y})
	for i = 1, #p do
		self:lineTo(p[i].x, p[i].y)
	end
end

local shape = Shape.new()
stage:addChild(shape)

shape:setLineStyle(2, 0x000000, 1)
shape:beginPath()
shape:moveTo(10, 10)
shape:catmulTo(0, 0, 10, 10, 50, 20, 20, 80)
shape:catmulTo(10, 10, 50, 20, 20, 80, 100, 100)
shape:catmulTo(50, 20, 20, 80, 100, 100, 110, 110)
shape:endPath()


local shape2 = Shape.new()
stage:addChild(shape2)

shape2:setLineStyle(2, 0xff0000, 1)
shape2:beginPath()
shape2:moveTo(10, 10)
shape2:lineTo(100, 100)
shape2:endPath()
